%define tarball xf86-video-qxl
%define moduledir %(pkg-config xorg-server --variable=moduledir )
%define driverdir	%{moduledir}/drivers

%define cvsdate xxxxxxx

Summary:   Xorg X11 qxl video driver
Name:      xorg-x11-drv-qxl
Version:   0.0.14
Release:   13%{?dist}
URL:       http://www.x.org
Source0:   http://xorg.freedesktop.org/releases/individual/driver/%{tarball}-%{version}.tar.bz2
Source1:   qxl.xinf
License: MIT
Group:     User Interface/X Hardware Support
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Patch1:  0001-Revert-use-spice-protocol-defines-for-ring-sizes.patch
Patch2:  0002-Add-old-driver-in-as-a-compatibility-layer.patch
Patch3:  0003-Link-in-the-compat-driver-various-renamings.patch
Patch4:  0004-If-qxl_pre_init-is-called-without-a-confScreen-just-.patch
Patch5:  0005-Transmit-images-in-smaller-chunks.patch
Patch6:  0006-Ignore-devices-classes-when-matching-PCI-devices.patch
Patch7:  0007-Only-save-the-VGA-fonts-for-the-primary-device.patch
Patch8:  0008-Reset-non-primary-device-out-of-CloseScreen.patch
Patch9:  0009-Add-support-for-parsing-various-options.patch
Patch10: 0010-Return-NULL-from-qxl_surface_create-when-surfaces-ar.patch
Patch11: 0011-Enable-caching-of-images-based-on-the-configuration-.patch
Patch12: 0012-options-Turn-surfaces-and-caching-on-by-default.patch

ExclusiveArch: %{ix86} x86_64

BuildRequires: pkgconfig
BuildRequires: xorg-x11-server-sdk >= 1.1.0-1
BuildRequires: glib2-devel
BuildRequires: spice-protocol >= 0.8.1

Requires:  Xorg %(xserver-sdk-abi-requires ansic)
Requires:  Xorg %(xserver-sdk-abi-requires videodrv)

%description
xorg-x11-qxl-drv is an X11 video driver for the QEMU QXL video
accelerator. This driver makes it possible to use Red Hat Enterprise
Linux 6 as a guest operating system under KVM and QEMU, using the
SPICE protocol.

%prep
%setup -q -n %{tarball}-%{version}
%patch1  -p1 -b .0001-Revert-use-spice-protocol-defines-for-ring-size.patch
%patch2  -p1 -b .0002-Add-old-driver-in-as-a-compatibility-layer.patch
%patch3  -p1 -b .0003-Link-in-the-compat-driver-various-renamings.patch
%patch4  -p1 -b .0004-If-qxl_pre_init-is-called-without-a-confScreen-just-.patch
%patch5  -p1 -b .0005-Transmit-images-in-smaller-chunks.patch
%patch6  -p1 -b .0006-Ignore-devices-classes-when-matching-PCI-devices.patch
%patch7  -p1 -b .0007-Only-save-the-VGA-fonts-for-the-primary-device.patch
%patch8  -p1 -b .0008-Reset-non-primary-device-out-of-CloseScreen.patch
%patch9  -p1 -b .0009-Add-support-for-parsing-various-options.patch
%patch10 -p1 -b .0010-Return-NULL-from-qxl_surface_create-when-surfaces-ar.patch
%patch11 -p1 -b .0011-Enable-caching-of-images-based-on-the-configuration-.patch
%patch12 -p1 -b .0012-options-Turn-surfaces-and-caching-on-by-default.patch

%build
aclocal -I .
autoreconf -vif
%configure --disable-static
make

%install
rm -rf $RPM_BUILD_ROOT

make install DESTDIR=$RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{_datadir}/hwdata/videoaliases
install -m 0644 %{SOURCE1} $RPM_BUILD_ROOT%{_datadir}/hwdata/videoaliases

# FIXME: Remove all libtool archives (*.la) from modules directory.  This
# should be fixed in upstream Makefile.am or whatever.
find $RPM_BUILD_ROOT -regex ".*\.la$" | xargs rm -f --

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%{driverdir}/qxl_drv.so
%{_datadir}/hwdata/videoaliases/qxl.xinf

%changelog
* Fri Mar 9 2012 Soren Sandmann <ssp@redhat.com> 0.0.14-13.el6
- Turn surfaces and caching on by default.
  Related: #708015

* Fri Mar 2 2012 Soren Sandmann <ssp@redhat.com> 0.0.14-12.el6
- Add support for caching and surface options
  Related: #708015

* Fri Feb 17 2012 Soren Sandmann <ssp@redhat.com> 0.0.14-11.el6
- Make sure the autoconf files are regenerated before building. 
  Fixes: #769116

* Tue Sep 27 2011 Soren Sandmann <ssp@redhat.com> 0.0.14-10.el6
- Add 0008-Reset-non-primary-device-out-of-CloseScreen.patch
  Fixes #741282

* Tue Sep 27 2011 Soren Sandmann <ssp@redhat.com> 0.0.14-9.el6
- Bump release for rebuilding.

* Tue Sep 27 2011 Soren Sandmann <ssp@redhat.com> 0.0.14-8.el6
- Add back in 0001-Rever-use-spice-protocol-defines-for-ring-size.patch
  that was accidentally dropped in -5.

* Tue Sep 20 2011 Soren Sandmann <ssp@redhat.com> 0.0.14-7.el6
- Bump spice-protocol requirement to 0.8.1

* Fri Aug 26 2011 Soren Sandmann <sandmann@redhat.com> 0.0.14-6.el6
- Bump for rebuild against rebased X server

* Mon Aug 22 2011 Soren Sandmann <sandmann@redhat.com> 0.0.14-5.el6
- Add patches 

	Ignore-devices-classes-when-matching-PCI-devices.patch
	Only-save-the-VGA-fonts-for-the-primary-device.patch

  both related to rhbz #730729.

* Wed Aug 10 2011 Soren Sandmann <sandmann@redhat.com> 0.0.14-4.el6
- Add chunks patch - rhbz #700392

* Mon Jul 18 2011 Adam Jackson <ajax@redhat.com> 0.0.14-3.el6
- Add xserver abi requires

* Fri Jul 15 2011 Soren Sandmann <ssp@redhat.com> 0.0.14-2.el6
- Add patch to revert broken use of I/O ports. rhbz #713857

* Thu Jul 14 2011 Soren Sandmann <ssp@redhat.com> 0.0.14-1.el6
- Rebase to latest upstream release. rhbz #713857

* Mon Mar 21 2011 Soren Sandmann <ssp@redhat.com> 0.0.12-8.el6
- Make %desc more descriptive. 
  Resolves: rhbz#684994

* Sun Mar 20 2011 Soren Sandmann <ssp@redhat.com> 0.0.12-8.el6
- Update release.

* Sun Mar 20 2011 Soren Sandmann <ssp@redhat.com> 0.0.12-7.el6
- Patch ("vt-switching") to make VT switching mostly work
  Related: rhbz:#680120

* Sun Mar 20 2011 Soren Sandmann <ssp@redhat.com> 0.0.12-6.el6
- Patches ("tighter-damage") to speed up zoom rectangles
  Resolves: rhbz#552000

* Sun Mar 20 2011 Soren Sandmann <ssp@redhat.com> 0.0.12-6.el6
- Patches ("readonly-surfaces", and "oom-issues") to avoid OOM issues
  Resolves: rhbz#680120

* Sun Mar 20 2011 Soren Sandmann <ssp@redhat.com> 0.0.12-6.el6
- Patch to fix crash when called from X -configure. 
  Resolves: rhbz#680865

* Fri Feb 4 2011 Soren Sandmann <ssp@redhat.com> 0.0.12-5.el6
- Add patch to support for rev 01 devices.

* Wed Jan 26 2011 Soren Sandmann <ssp@redhat.com> 0.0.12-4.el6
- Add surfaces patch 

* Sun Oct 17 2010 Hans de Goede <hdegoede@redhat.com> 0.0.12-3.el6
- Fix crash and vga font corruption when switching vc
  Resolves: rhbz#626508
- Add support for many more resolutions and enable resolutions > 1024x768
  without requiring an xorg.conf
  Resolves: rhbz#623652

* Tue Feb 9 2010 Soren Sandmann <ssp@redhat.com> 0.0.12-2.1.el6
- Remove a couple of obsolete asserts(). 

* Tue Feb 9 2010 Soren Sandmann <ssp@redhat.com> 0.0.12-1.1.el6
- Version 0.0.12

* Fri Jan 22 2010 Soren Sandmann <ssp@redhat.com> 0.0.8-1.1.el6
- Version 0.0.8

* Tue Feb 24 2009 Soren Sandmann <ssp@redhat.com> 0.0.1-1.1
- Initial package
